package com.example.programs;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class EmployeeDemo {

	public static void main(String[] args) {

		List<Employee> list = new ArrayList<Employee>();
		list.add(new Employee(1, "Ali-1", 1000, "IT"));
		list.add(new Employee(2, "Ali-2", 1500, "HR"));
		list.add(new Employee(3, "Ali-3", 100, "IT"));
		list.add(new Employee(4, "Ali-4", 900, "HR"));
		list.add(new Employee(5, "Ali-5", 1800, "Network"));
		list.add(new Employee(6, "Ali-6", 3000, "Network"));

		List<String> cityOfIndia = new ArrayList<String>();
		cityOfIndia.add("Delhi");
		cityOfIndia.add("Mumbai");
		cityOfIndia.add("Pune");
		cityOfIndia.add("Bangalore");

		List<String> cityOfUAS = new ArrayList<String>();
		cityOfIndia.add("New York");
		cityOfIndia.add("Washington DC");
		cityOfIndia.add("Las Vegas");
		cityOfIndia.add("Silicaon Valley");

		Map<String, List<Employee>> empList = list.stream()
				.collect(Collectors.groupingBy(Employee::getDept, Collectors.toList()));
		empList.entrySet().forEach(System.out::println);
		System.out.println("-----------------------------------------------------");

		List<Employee> empListSorted = list.stream().sorted(Comparator.comparing((Employee::getSalary)))
				.collect(Collectors.toList());
		empListSorted.forEach(System.out::println);
		System.out.println("-----------------------------------------------------");

		List<List<String>> city = new ArrayList<List<String>>();
		city.add(cityOfIndia);
		city.add(cityOfUAS);
		city.stream().flatMap(x->x.stream().sorted()).distinct().forEach(System.out::println);

	}

}
